import Controller from '@ember/controller';
import { tracked } from '@glimmer/tracking';
import { action } from '@ember/object';

export default class ApplicationController extends Controller {
    @tracked a;
    @tracked b;
    @tracked result;
    @tracked operators = '+';
    @tracked hasCalculated = false;
    @tracked hasCalculatedOnce = false;
    @tracked historyArray = [];
    @tracked historyArrayClearInformation = [];


    @action 
    calculate(event) {
        event.preventDefault();
        this.hasCalculated = true;
        this.hasCalculatedOnce = true;
        switch (this.operators) {
            case '+':
                this.result = parseInt(this.a) + parseInt(this.b);
                break;
            case '-':
                this.result = parseInt(this.a) - parseInt(this.b);
                break;
            case '*':
                this.result = parseInt(this.a) * parseInt(this.b);
                break;
            case '/':
                this.result = parseInt(this.a) / parseInt(this.b);
                break;
            case '%':
                this.result = parseInt(this.a) % parseInt(this.b);
                break;
            default:
                break;
        }
        this.historyArray.pushObject(this.a.toString().concat(" ", this.operators, " ", this.b.toString(), " = ", this.result.toString()));
        this.historyArrayClearInformation.push([this.a, this.b, this.operators, this.result])
    }

    @action
    typing(){
        this.hasCalculated = false;
    }

    @action
    updateValue(value){
        this.operators = value;
    }

    @action
    update(){
        this.historyArray = this.historyArray;
    }

    @action
    rerun(index){
        this.a = this.historyArrayClearInformation[index][0];
        this.b = this.historyArrayClearInformation[index][1];
        this.operators = this.historyArrayClearInformation[index][2];
        this.result = this.historyArrayClearInformation[index][3];
        
        this.historyArray.pushObject(this.a.toString().concat(" ", this.operators, " ", this.b.toString(), " = ", this.result.toString()));
        this.historyArrayClearInformation.push([this.a, this.b, this.operators, this.result])
    }
    
}
