import Controller from '@ember/controller';
import { action } from "@ember/object";

export default class ModulesEditController extends Controller {
    @action
    updateModule(event) {
        event.preventDefault();
        this.errorCode = '';
        this.errorName = '';
        this.errorSemester = '';
        this.model.save().then((model) => {
            this.transitionToRoute('modules.view', model.id)
        }).catch((response) => {
            response.errors.forEach((error) =>{
                if(error.source.pointer == '/data/attributes/code') {
                    this.errorCode = error.detail;
                } else if(error.source.pointer == '/data/attributes/name') {
                    this.errorName = error.detail;
                } else if(error.source.pointer == '/data/attributes/semester') {
                    this.errorSemester = error.detail;
                }
            })
        })
    }

    @action
      resetModule(event) {
      event.preventDefault();
      if(this.model.hasDirtyAttributes) {
        this.model.rollbackAttributes();
      }
      this.transitionToRoute('modules.view', this.model.id)
    }

    @action
    setSemester(semester) {
        this.model.semester = semester;
    }
}