import Controller from '@ember/controller';
import { action } from "@ember/object";
import { tracked } from "@glimmer/tracking";

export default class ModulesNewController extends Controller {
    @tracked newCode = '';
    @tracked newName = '';
    @tracked newSemester = 'WS18/19';
    @tracked errorCode = '';
    @tracked errorName = '';
    @tracked errorSemester = '';

    @action
    createModule(event) {
        event.preventDefault();
        let newModule = this.store.createRecord('module', {
            code: this.newCode,
            name: this.newName,
            semester: this.newSemester,
            teacher: this.model
        })
        this.errorCode = '';
        this.errorName = '';
        this.errorSemester = '';
        newModule.save().then((module) => {
            this.transitionToRoute('modules.view', module.id)
        }).catch((response) => {
            response.errors.forEach((error) => {
                if(error.source.pointer == '/data/attributes/code') {
                    this.errorCode = error.detail;
                } else if(error.source.pointer == '/data/attributes/name') {
                    this.errorName = error.detail;
                } else if(error.source.pointer == '/data/attributes/semester') {
                    this.errorSemester = error.detail;
                }
            })
        })
    }

    @action
    setNewSemester(value) {
        this.newSemester = value;
    }
}

