import React from 'react';
import ReactDOM from 'react-dom';

import '../styles/app.scss';

export default class Athena extends React.Component {

    constructor(props) {
        super(props);

        this.state =  {
            a : null,
            b : null,
            operator : '+',
            result : null,
            hasCalculated : false,
            pastCalculations : []
        }
    }


    updateOperator = (ev) => {
        this.setState({
            operator: ev.target.value,
            hasCalculated: false
        });
    }

    updateA = (ev) => {
        this.setState({
            a: ev.target.value
        });
    }

    updateB = (ev) => {
        this.setState({
            b: ev.target.value
        });
    }

    calcChange = (ev) =>{
        this.setState({
            hasCalculated : true
        });
    }

    

    calcResult = (ev) => {
        ev.preventDefault();
        switch (this.state.operator) {
            case '+':
                this.setState({
                    result: Number(this.state.a) + Number(this.state.b)
                })
                break;
            case '-':
                this.setState({
                    result: Number(this.state.a) - Number(this.state.b)
                })
                break;
            case '*':
                this.setState({
                    result: Number(this.state.a) * Number(this.state.b)
                })
                break;
            case '/':
                this.setState({
                    result: Number(this.state.a) / Number(this.state.b)
                })
                break;
            case '%':
                this.setState({
                    result: Number(this.state.a) % Number(this.state.b)
                })
                break;
            default:
                break;
        }
        this.state.pastCalculations.push(String(this.state.a).concat( String(this.state.operator) ).concat( String(this.state.b) ).concat( " = " ).concat( String(this.state.result) ) )
    }


    render() {
        let listCalculations = this.state.pastCalculations.map((calculation) =>
            <li>{calculation}</li>
        );

        return (
            <div>
                <main className="grid-container-x small callout">
                    <h1>Calculator</h1>
                    <form action="index.html" onSubmit= {this.calcResult}>
                        <div>
                            <label>Number One
                                <input type="number" name="a" placeholder="1, 1235, 123995.233, etc." tabIndex="1" required="required" value={this.state.a} onChange={this.updateA}/>
                            </label>
                        </div>
                        <div>
                            <label>Operation
                                <select name="operators" onChange={this.updateOperator}>
                                    <option value="+">+</option>
                                    <option value="-">-</option>
                                    <option value="*">*</option>
                                    <option value="/">/</option>
                                    <option value="%">%</option>
                                </select>
                        </label>
                        </div>
                        <div>
                            <label>Number Two
                                <input type="number" name="b" placeholder="1, 1235, 123995.233, etc." tabIndex="2" required="required" value={this.state.b} onChange={this.updateB} />
                            </label>
                        </div>
                        <div className="text-center">
                            <button tabIndex="3" class="button" onClick={this.calcChange}>Calculate</button>
                        </div>
                        {
                            this.state.hasCalculated?
                            
                            <div>
                                <label id="result">
                                    {this.state.a} {this.state.operator} {this.state.b} = {this.state.result}
                                </label>
                            </div>

                            :

                            <div></div>

                        }
                        {
                            listCalculations.length > 0 ?

                            <div>
                                <ul>
                                    {listCalculations}
                                </ul>
                            </div>
                                     
                            : 

                            <div></div>

                        }
                    </form>
                </main>
            </div>
        )
    }
}

ReactDOM.render(<Athena/>, document.getElementById('app-entry-point'));